<template lang="pug">
.video
  .row
    .absolute-full
      q-media-player.full-height(
        type="video",
        :muted="muted",
        :autoplay="true",
        :sources="sources",
        no-controls,
        :loop="loop",
        ref="mediaplayer",
        :show-spinner="false",
        :show-big-play-button="false",
        @ended="onEnded",
        @ready="ready()",
        @duration="updateDuration",
        @timeupdate="updateTime",
        @error="updateError",
        :volume="volume",
        @mediaPlayer="updateStatus('loading')"
      )
</template>

<script>
// import throttle from "quasar/src/utils/throttle";
import { throttle } from "quasar";

export default {
  name: "VideoOverlay",
  props: {
    firebase: {
      required: true,
    },
    functions: {
      required: true,
    },
    context: {
      required: false,
    },
  },
  created() {
    this.updateTime = throttle(this.updateTime, 1000);
  },
  computed: {
    volume() {
      return this.video.volume || 100;
    },
    muted() {
      return typeof this.video.muted != "undefined" ? this.video.muted : true;
    },
    loop() {
      return typeof this.video.loop != "undefined" ? this.video.loop : true;
    },
  },
  methods: {
    ready() {
      this.updateStatus("ready");
      //update duration (fix for if the same src is used across script items):
      // console.log(this.$refs.mediaplayer.$media.duration);
      this.updateDuration(this.$refs.mediaplayer.$media.duration);
    },
    async onEnded() {
      //do something to trigger next stage (done through progression logic)
      console.log("Triggering advance");
      this.advancing = true;
      await this.functions.httpsCallable("config-onPluginTriggerAdvance")({
        meetingId: this.context.meetingid,
      });
    },
    async updateError(err) {
      if (!this.advancing) {
        if (this.video.src) {
          this.firebase
            .ref(
              `config/${this.context.meetingid}/current/currentState/plugins/video/error`
            )
            .set(err.message);
          this.updateStatus("error");
        }
      }
    },
    async updateStatus(status) {
      // console.log(status);
      if (status != "error") {
        await this.firebase
          .ref(
            `config/${this.context.meetingid}/current/currentState/plugins/video/error`
          )
          .set(null);

        await this.firebase
          .ref(
            `config/${this.context.meetingid}/current/currentState/plugins/video/status`
          )
          .set(status);
      }
    },
    async updateDuration(duration) {
      // console.log("updating duration");
      // if (this.duration == -1) this.duration = duration;
      // console.log(duration);
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/video/duration`
        )
        .set(duration);
    },
    async updateTime(duration) {
      await this.firebase
        .ref(
          `config/${this.context.meetingid}/current/currentState/plugins/video/time`
        )
        .set(duration);
    },
  },
  data: () => {
    return {
      video: {},
      sources: [],
      advancing: false,
      duration: -1,
    };
  },
  watch: {
    video: {
      deep: true,
      async handler(newVal, oldVal) {
        if (newVal.requestedTime) {
          this.firebase
            .ref(
              `config/${this.context.meetingid}/current/currentState/plugins/video/requestedTime`
            )
            .set(null);
          this.$refs.mediaplayer.setCurrentTime(newVal.requestedTime);
        }

        //only update when the src changes, not any other vars
        if (newVal.src != oldVal.src) {
          // console.log("changing source");
          //change source:
          // this.duration = -1;
          this.sources = [
            {
              src: this.video.src,
              type: "video/mp4",
            },
          ];
        }

        //detecting a script item move
        if (!newVal.duration && oldVal.duration) {
          // console.log("item changed");
          this.$refs.mediaplayer.setCurrentTime(0);
          this.updateDuration(this.$refs.mediaplayer.$media.duration);
        }
      },
    },
    firebase: {
      immediate: true,
      handler() {
        this.$rtdbBind(
          "video",
          this.firebase.ref(
            `config/${this.context.meetingid}/current/currentState/plugins/video`
          )
        );
      },
    },
  },
};
</script>
